#include "Vram.h"
#include "VVram.h"
#include "CopyMemory.h"
#include "Chars.h"

static const byte[] ColorSource = {
    Char_CrackedFloor, 9, 0x45,
    Char_Ladder_Left, 6, 0x46,
    Char_Remain, 8, 0x47,
    Char_Monster, 32, 0x43,
    0xff
};

byte[256] CharColors;

static void SetColor(ptr<byte> pColor, byte color, byte count)
{
    do {
        *pColor = color;
        ++pColor;
        --count;
    } while (count != 0);
}

void InitVram()
{
    ptr<byte> pColor, pSource;

    pColor = CharColors;
    repeat (0) {
        *pColor = 0x07;
        ++pColor;
    }

    pSource = ColorSource;
    while (pSource[0] != 0xff) {
        byte count, color;
        pColor = CharColors + pSource[0];
        count = pSource[1];
        color = pSource[2];
        pSource += 3;
        do {
            *pColor = color;
            ++pColor;
            --count;
        } while (count > 0);
    }

    SetPattern(Char_CrackedFloor, Pattern_CrackedFloor, 8 + 3 + 4);
    SetPattern(Char_Remain, Pattern_Man, 4);
    SetPattern(Char_Monster, Pattern_Monster, 4 * 4 * 2);
}


void ClearScreen()
{
    FillMemory(Vram, VramWidth * VramHeight, Char_Space);
    FillMemory(Attr, VramWidth * VramHeight, 0x07);
}


void Put2C(ptr<byte> pVram, byte c, byte color)
{
    repeat (2) {
        repeat (2) {
            pVram = Put(pVram, c, color);
            ++c;
        }
        pVram += VramRowSize - 2 * VramStep;
    }
}
