include "Vram.inc"
include "VVram.inc"

ext @Temp@Word
ext @Temp@word2
ext @Temp@Word3
ext @Temp@Byte
ext @Temp@Byte2
ext @Temp@Byte3

zseg
@Temp@Word4:
    defw 0

VramTop equ Vram+VramWidth*2

ext VVramFront_, RowFlags_
ext ClearRowFlags_
ext Chars_
ext CharColors_

pVVram equ @Temp@Word
pVram equ @Temp@Word2
pColor equ @Temp@Word3
pFlags equ @Temp@Word4
bit equ @Temp@Byte3
xCount equ @Temp@Byte
yCount equ @Temp@Byte2


; void SetPattern(byte c, byte pattern, byte count);
pSource equ @Temp@Word
pDestination equ @Temp@Word2
charGen equ @Temp@Byte3
dseg
SetPattern_@Param1: public SetPattern_@Param1
    defb 0
SetPattern_@Param2: public SetPattern_@Param2
    defb 0
cseg
SetPattern_: public SetPattern_
    psha | pshb
        suba #$80
        if cc
            ldab #high CharGen1
            stab <charGen
        else
            adda #$80
            ldab #high CharGen0
            stab <charGen
        endif
        staa <pDestination+1 | clr <pDestination
        asl <pDestination+1 | rol <pDestination ;*2
        asl <pDestination+1 | rol <pDestination ;*4
        asl <pDestination+1 | rol <pDestination ;*8
        ldaa <pDestination
        adca <charGen
        staa <pDestination

        ldaa SetPattern_@Param1
        staa <pSource+1 | clr <pSource
        asl <pSource+1 | rol <pSource ;*2
        asl <pSource+1 | rol <pSource ;*4
        asl <pSource+1 | rol <pSource ;*8
        ldaa <pSource+1 
        adda #low Chars_
        staa <pSource+1
        ldaa <pSource
        adca #high Chars_
        staa <pSource

        ldab SetPattern_@Param2
        aslb ;*2
        aslb ;*4
        aslb ;*8
        do
            ldx <pSource
            ldaa 0,x
            inx
            stx <pSource

            ldx <pDestination
            staa 0,x
            inx
            stx <pDestination

            decb
        while ne | wend
    pulb | pula
rts


; void Put(ptr<byte> pVram, byte c, byte color);
dseg
Put_@Param0: public Put_@Param0
Put_pVram:
    defw 0
Put_@Param1: public Put_@Param1
Put_c:
    defb 0
Put_@Param2: public Put_@Param2
Put_color:
    defb 0
cseg
Put_: public Put_
    psha
        ldx Put_pVram
        ldaa Put_c
        staa 0,x
        stx <pVram
        ldaa <pVram | adda #$04 | staa <pVram
        ldx <pVram
        ldaa Put_color
        staa 0,x
        ldx Put_pVram
        inx
    pula
rts


; ptr<byte> PrintC(ptr<byte> pVram, byte c);
dseg
PrintC_@Param0: public PrintC_@Param0
PrintC_pVram:
    defw 0
PrintC_@Param1: public PrintC_@Param1
PrintC_c:
    defw 1
cseg
PrintC_: public PrintC_
    psha
        ldx PrintC_pVram
        ldaa PrintC_c
        staa 0,x
        stx <pVram
        ldaa <pVram | adda #$04 | staa <pVram
        ldaa #$07 | ldx <pVram | staa 0,x
        ldaa <pVram | adda #-$04 | staa <pVram
        ldx <pVram
        inx
    pula
rts


cseg
VVramToVramRow:
    ldab #VVramWidth
    stab <xCount
    do
        ldx <pVVram | ldaa 0,x | inx | stx <pVVram
        staa VVramToVramRow_load+1
        cmpa #$a0
        if cc
            suba #$20
        endif
        ldx <pVram | staa 0,x
        
        ldx #CharColors_
        VVramToVramRow_load:
        ldab 0,x
        
        ldaa <pVram | adda #$04 | staa <pVram
        ldx <pVram | stab 0,x
        ldaa <pVram | adda #-$04 | staa <pVram
        
        ldx <pVram | inx | stx <pVram
        dec <xCount
    while ne | wend
    ; ldaa <pVram+1 | adda #VramWidth-VVramWidth | staa <pVram+1
rts

; void VVramToVramAll();
VVramToVramAll_yCount equ @Temp@Byte2
cseg
VVramToVramAll_:　public	VVramToVramAll_
    psha | pshb
        ldx #VramTop | stx <pVram
        ldx #VVramFront_+VVramWidth | stx <pVVram
        ldab #VVramHeight-2 | stab <yCount
        do
            bsr VVramToVramRow
            dec <yCount
        while ne | wend
    pulb | pula
rts


; void VVramToVramChanged();
cseg
VVramToVramChanged_: public VVramToVramChanged_
    psha | pshb
        ldx #VramTop | stx <pVram
        ldx #VVramFront_+VVramWidth | stx <pVVram
        ldx #RowFlags_
        ldab 0,x
        inx
        stx <pFlags
        ldaa #2
        staa <bit
        ldaa #VVramHeight-2 | staa <yCount
        do
            bitb <bit
            if ne
                pshb
                    bsr VVramToVramRow
                pulb
            else
                ldaa <pVram+1 | adda #low VramWidth | staa <pVram+1
                ldaa <pVram | adca #high VramWidth | staa <pVram 

                ldaa <pVVram+1 | adda #low VVramWidth | staa <pVVram+1
                ldaa <pVVram | adca #high VVramWidth*2 | staa <pVVram
            endif
            asl <bit
            if eq
                ldx <pFlags
                ldab 0,x
                inx
                stx <pFlags
                ldaa #1
                staa <bit
            endif
            dec <yCount
        while ne | wend
        clr RowFlags_
        clr RowFlags_+1
        clr RowFlags_+2
    pulb | pula
rts
